/*
	MicroView.win Copyright 1995 }V
	oga@dgw.yz.yamagata-u.ac.jp
*/

#include	"microview.h"
#include	<string.h>

#define		Print(msg)	ConsoleAutoPrint(msg)
#define		FOFF		1024

static unsigned char	_KanjiC[]= {
	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,

	1,1,1,1,1,1,1,1, 1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1, 1,1,1,1,1,1,1,1,
	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
	1,1,1,1,1,1,1,1, 1,1,1,1,1,1,1,1,
	1,1,1,1,0,0,0,0, 0,0,0,0,0,0,0,0,
};

static unsigned char *
MakeBuf( bp, size )
T_BUFP	*bp;
int size;
{
	unsigned char	*ptr= (unsigned char*)(bp->lp)+ FOFF,
			*last= ptr+ size,
			*str= bp->fbuf,
			**lp= bp->lp;
	int	line, jison= FALSE;
	for( line= 0 ; ptr < last ; line++ ){
		unsigned char	kanji= 0;
		int	col;
		*lp++= str;
		for( col= 0 ; col < bp->maxcol ;){
			if( *ptr < ' ' ){
				if( *ptr == '\t' ){
					int l= bp->tabsize-(col&bp->tabmask);
					for( ptr++,col+=l; l-- ; *str++= ' ');
					continue;
				}else if( *ptr == '\x08' ){
					if( col ){
						str--;
						col--;
					}
					ptr++;
					continue;
				}else if( *ptr == '\n' ){
					ptr++;
					break;
				}else if( *ptr == '\r' ){
					if( ptr[1] == '\n' )
						ptr++;
					ptr++;
					break;
				}else if( *ptr == 0x1b ){
					switch( *++ptr ){
					case 0x24:			/* JIS in  $ */
						jison= TRUE;
						ptr++;
						break;
					case 0x28:			/* JIS out ( */
						jison= FALSE;
						ptr++;
						break;
					}
					ptr++;
					continue;
				}
			}
			if( jison ){
				kanji= 0;
				if( col < bp->maxcol - 1 ){
					unsigned short c= *ptr++;
					c= ( c << 8 ) | *ptr++;
					c= JISSFT( c );	/* JIS to SJIS */
					*str++= ( c >> 8 ) & 0xff;
					*str++= c & 0xff;
					col+= 2;
				}else {
					break;
				}
			}else {
				kanji= kanji ? 0 : _KanjiC[*ptr];
				*str++= *ptr++;
				col++;
			}
		}
		if( kanji ){
			str--;
			ptr--;
		}
		*str++= '\0';
	}
	bp->line= line;
	return	str;
}

int
ReadFile( bp )
T_BUFP	*bp;
{
	int	fn;
	if( (fn= OPEN( bp->fname, 0 )) >= 0 ){
		int	fsize= SEEK( fn, 0, 2 );
		SEEK( fn, 0, 0 );
		if( (int)(bp->lp= MALLOC( fsize+FOFF )) < 0 ){
			CLOSE( fn );
			Print( "tview:Can't alloc memory.\r\n" );
			return	0;
		}
		READ( fn, (char*)(bp->lp)+FOFF, fsize );
		CLOSE( fn );
		if( (int)(bp->fbuf= MALLOC( fsize*2 )) < 0 ){
			Print( "tview:Can't alloc memory.\r\n" );
			return	0;
		}
		fsize= MakeBuf( bp, fsize )-bp->fbuf;
		SETBLOCK( bp->fbuf, fsize );
		SETBLOCK( bp->lp, sizeof(char*)*bp->line );
		return	fsize;
	}
	Print( "tview:open error\r\n" );
	return	0;
}

int
SetBuf( bp, ptr )
T_BUFP	*bp;
unsigned char	*ptr;
{
	int	fsize= strlen( ptr );
	if( (int)(bp->lp= MALLOC( fsize+FOFF )) < 0 ){
		Print( "tview:Can't alloc memory.\r\n" );
		return	0;
	}
	strcpy( (char*)(bp->lp)+FOFF, ptr );
	if( (int)(bp->fbuf= MALLOC( fsize*2 )) < 0 ){
		Print( "tview:Can't alloc memory.\r\n" );
		return	0;
	}
	fsize= MakeBuf( bp, fsize )-bp->fbuf;
	SETBLOCK( bp->fbuf, fsize );
	SETBLOCK( bp->lp, sizeof(char*)*bp->line );
	return	fsize;
}

#if 0
main( argc, argv )
char	**argv;
{
	int	size;
	T_BUFP	bb;
	bb.tabsize= 8;
	bb.tabmask= 7;
	bb.maxcol= 40;
	bb.fname= *++argv;
	size= ReadFile( &bb );
	{
		int	i;
		for( i= 0 ; i< bb.line ; i++ ){
			Print( bb.lp[i] );
			Print( "\r\n" );
		}
	}
}
#endif
